//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmMain *frmMain;
//---------------------------------------------------------------------------
__fastcall TfrmMain::TfrmMain(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
// Button Load Click Event
void __fastcall TfrmMain::btnLoadClick(TObject *Sender)
{
  opnFile->Execute(); // Show open dialog
  imgBitmap->Picture->LoadFromFile(opnFile->FileName); // Load the bitmap from file
  imgBitmap->Width = imgBitmap->Picture->Bitmap->Width; // Get bitmap width
  imgBitmap->Height = imgBitmap->Picture->Bitmap->Height; // Get bitmap height
  imgHex->Width = imgBitmap->Picture->Bitmap->Width; // Set hex width with the bitmap width
  imgHex->Height = imgBitmap->Picture->Bitmap->Height; // Set hex height with the bitmap height
  RefreshHex(); // Start the transformation
}
//---------------------------------------------------------------------------
// Form Create Event
void __fastcall TfrmMain::FormCreate(TObject *Sender)
{
  // Define here the colors value of hex image
  // Must be the same on VHD code
  Colors[0][0] = 255; Colors[0][1] = 255; Colors[0][2] = 255;
  Colors[1][0] = 255; Colors[1][1] =   0; Colors[1][2] =   0;
  Colors[2][0] =   0; Colors[2][1] = 255; Colors[2][2] =   0;
  Colors[3][0] =   0; Colors[3][1] =   0; Colors[3][2] = 255;
}
//---------------------------------------------------------------------------
// Make the conversion to hex color
void TfrmMain::RefreshHex(void){
  int x, y; // Counter for loops
  int rgb[3], len[NUM_CLR]; // Array for RBG store

  // Creating points matrix
  Matrix = new int*[imgBitmap->Width];
  for(x = 0; x < imgBitmap->Width; x++){
    Matrix[x] = new int[imgBitmap->Height];
  }
  // For each point, calcule the closest color
  for(y = 0; y < imgBitmap->Height; y++){
    for(x = 0; x < imgBitmap->Width; x++){
      rgb[0] = (imgBitmap->Picture->Bitmap->Canvas->Pixels[x][y] & 0x000000FF);
      rgb[1] = (imgBitmap->Picture->Bitmap->Canvas->Pixels[x][y] & 0x0000FF00) >>  8;
      rgb[2] = (imgBitmap->Picture->Bitmap->Canvas->Pixels[x][y] & 0x00FF0000) >> 16;
      len[0] = ((rgb[0] - Colors[0][0]) * (rgb[0] - Colors[0][0])) +
               ((rgb[1] - Colors[0][1]) * (rgb[1] - Colors[0][1])) +
               ((rgb[2] - Colors[0][2]) * (rgb[2] - Colors[0][2]));
      len[1] = ((rgb[0] - Colors[1][0]) * (rgb[0] - Colors[1][0])) +
               ((rgb[1] - Colors[1][1]) * (rgb[1] - Colors[1][1])) +
               ((rgb[2] - Colors[1][2]) * (rgb[2] - Colors[1][2]));
      len[2] = ((rgb[0] - Colors[2][0]) * (rgb[0] - Colors[2][0])) +
               ((rgb[1] - Colors[2][1]) * (rgb[1] - Colors[2][1])) +
               ((rgb[2] - Colors[2][2]) * (rgb[2] - Colors[2][2]));
      len[3] = ((rgb[0] - Colors[3][0]) * (rgb[0] - Colors[3][0])) +
               ((rgb[1] - Colors[3][1]) * (rgb[1] - Colors[3][1])) +
               ((rgb[2] - Colors[3][2]) * (rgb[2] - Colors[3][2]));
      if((len[0] < len[1]) && (len[0] < len[2]) && (len[0] < len[3])){
        imgHex->Canvas->Pixels[x][y] = (0x00000000) |
        (Colors[0][2] << 16) | (Colors[0][1] << 8) | Colors[0][0];
        Matrix[x][y] = 0;
      }
      else if((len[1] < len[0]) && (len[1] < len[2]) && (len[1] < len[3])){
        imgHex->Canvas->Pixels[x][y] = (0x00000000) |
        (Colors[1][2] << 16) | (Colors[1][1] << 8) | Colors[1][0];
        Matrix[x][y] = 1;
      }
      else if((len[2] < len[0]) && (len[2] < len[1]) && (len[2] < len[3])){
        imgHex->Canvas->Pixels[x][y] = (0x00000000) |
        (Colors[2][2] << 16) | (Colors[2][1] << 8) | Colors[2][0];
        Matrix[x][y] = 2;
      }
      else if((len[3] <= len[0]) && (len[3] <= len[1]) && (len[3] <= len[2])){
        imgHex->Canvas->Pixels[x][y] = (0x00000000) |
        (Colors[3][2] << 16) | (Colors[3][1] << 8) | Colors[3][0];
        Matrix[x][y] = 3;
      }
    }
  }
  imgHex->Refresh(); // Show the picture with new colors
}
//---------------------------------------------------------------------------
// Button Save Event, save in hex file format
void __fastcall TfrmMain::btnSaveClick(TObject *Sender)
{
  FILE *p; // File pointer
  char FileName[512]; // File Name
  int endereco, endH, endL, check, i, j, k, pt, tmp, cor[4];
  long int BLN, SZE;

  savFile->Execute(); // Open save dialog
  StrPCopy(FileName, savFile->FileName); 
  // Get the start address from user
  endereco = StrToInt(InputBox("Endereo", "Digite o Endereo Inicial", "0"));

  p = fopen(FileName, "w"); // Create the file

  // Calculing BLN and SZE from bitmap width and height
  BLN = (imgHex->Width / 4);
  SZE = imgHex->Height * BLN;
  for(i = 0; i < SZE/BLN; i++)
  {
   // PASSO 1: imprime o inicio do record e inicializa o checksum (soma)
   fprintf(p, ":");
   print_hex(p, BLN);
   check = BLN;

   // PASSO 2: imprime o endereco o endereco e avanca BLN bytes
   endH = endereco / 256;
   endL = endereco - endH * 256;
   endereco += BLN;
   print_hex(p, endH);
   check += endH;
   print_hex(p, endL);
   check += endL;

   // PASSO 3: imprime 0 tipo do record
   print_hex(p, 0x00);

   // PASSO 4: imprime os BLN bytes da linha
   for(j = 0; j < BLN; j++)
   {
     tmp = 0;
     for(k = j * 4; k < (j * 4) + 4; k++){
       if(Matrix[k][i] == 0) tmp = (tmp >> 2) + 0;
       else if(Matrix[k][i] == 1) tmp = (tmp >> 2) + 64;
       else if(Matrix[k][i] == 2) tmp = (tmp >> 2) + 128;
       else if(Matrix[k][i] == 3) tmp = (tmp >> 2) + 192;
     }
     print_hex(p, tmp);
     check += tmp;
   }

   // PASSO 5: fim da linha, gera o complemento de dois do checksum (soma)
   check = -check ;
   check = check & 0x000000FF;
   print_hex(p, check);
   fprintf(p,"\n");
  }
  fprintf(p,":00000001FF\n");       // FECHA O ARQUIVO
  fclose(p);
}
//---------------------------------------------------------------------------
// Print into the file a integer in hexdecimal format
void TfrmMain::print_hex(FILE *F, int hex)
{  int i;
   char str[10];

   sprintf(str,"%2x", hex);   // COLOCA EM UMA STRING
   for(i=0; i<2; i++)
	 if(str[i]==' ')
              fprintf(F,"0");
         else fprintf(F,"%c", toupper((int)str[i]));
}
